Index: trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 716)
@@ -235,7 +235,10 @@
                           (  0.75 * QREFvis3d(ig,l,iaer) /        &
                           ( rho_ice * reffrad(ig,l,iaer) )  ) *   &
-                            pq(ig,l,i_h2oice) *                   & !JL I dropped the +1e-9 here to have the same
-                          ( pplev(ig,l) - pplev(ig,l+1) ) / g /   & !   opacity in the clearsky=true and the 
-                            CLF1				    !   clear=false/pq=0 case
+                          !  pq(ig,l,i_h2oice) *                   & !JL I dropped the +1e-9 here to have the same
+                          !( pplev(ig,l) - pplev(ig,l+1) ) / g /   & !   opacity in the clearsky=true and the 
+                          !  CLF1				    !   clear=false/pq=0 case
+                          ( pq(ig,l,i_h2oice) + 1.E-9 ) *         & ! Doing this makes the code unstable, so I have restored it (RW)
+                          ( pplev(ig,l) - pplev(ig,l+1) ) / g /   &  
+                            CLF1
 
                      aerosol(ig,l,iaer) = -log(1 - CLF2 + CLF2*exp(-aerosol0)) 
Index: trunk/LMDZ.GENERIC/libf/phystd/bilinear.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/bilinear.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/bilinear.F90	(revision 716)
@@ -1,80 +1,18 @@
 !-------------------------------------------------------------------------
-      subroutine bilinear(x_arr,y_arr,nX,nY,f2d_arr,x_in,y_in,f)
-!     Necessary for interpolation of continuum data
+subroutine bilinear(f,f11,f21,f12,f22,x,x1,x2,y,y1,y2)  
+! Used for interpolation of continuum data
 
-      implicit none
+  implicit none
 
-      integer nX,nY,i,j,a,b
+  real*8 x,y,x1,x2,y1,y2
+  real*8 f,f11,f12,f21,f22,fA,fB
 
-      real*8 x_in,y_in,x,y,x1,x2,y1,y2
-      real*8 f,f11,f12,f21,f22,fA,fB
-      real*8 x_arr(nX)
-      real*8 y_arr(nY)
-      real*8 f2d_arr(nX,nY)
-      
-      integer strlen
-      character*100 label
-      label='subroutine bilinear'
+  ! 1st in x-direction
+  fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
+  fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
 
-      x=x_in
-      y=y_in
+  ! then in y-direction
+  f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
 
-!     1st check we're within the wavenumber range
-      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
-         f=0.0D+0
-         return
-      else
-         
-!     in the x (wavenumber) direction 1st
-         i=1
- 10      if (i.lt.(nX+1)) then
-            if (x_arr(i).gt.x) then
-               x1=x_arr(i-1)
-               x2=x_arr(i)
-               a=i-1
-               i=9999
-            endif
-            i=i+1
-            goto 10
-         endif
-      endif
-      
-      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
-         write(*,*) 'Warning from bilinear.for:'
-         write(*,*) 'Outside continuum temperature range!'
-         if(y.lt.y_arr(1))then
-            y=y_arr(1)+0.01
-         endif
-         if(y.gt.y_arr(nY))then
-            y=y_arr(nY)-0.01
-         endif
-      else
-
-!     in the y (temperature) direction 2nd
-         j=1
- 20      if (j.lt.(nY+1)) then
-            if (y_arr(j).gt.y) then
-               y1=y_arr(j-1)
-               y2=y_arr(j)
-               b=j-1
-               j=9999
-            endif
-            j=j+1
-            goto 20
-         endif
-      endif
-      
-      f11=f2d_arr(a,b)
-      f21=f2d_arr(a+1,b)
-      f12=f2d_arr(a,b+1)
-      f22=f2d_arr(a+1,b+1)
-      
-!     1st in x-direction
-      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
-      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
-      
-!     then in y-direction
-      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
-      
-      return
-    end subroutine bilinear
+  return
+end subroutine bilinear
Index: trunk/LMDZ.GENERIC/libf/phystd/calc_cpp_mugaz.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/calc_cpp_mugaz.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/calc_cpp_mugaz.F90	(revision 716)
@@ -40,4 +40,5 @@
             ! all values at 300 K from Engineering Toolbox
             if(gnom(igas).eq.'CO2')then
+               !cpp_c   = cpp_c   + 0.744*gfrac(igas) ! @ ~210 K (better for Mars conditions) 
                cpp_c   = cpp_c   + 0.846*gfrac(igas)
                mugaz_c = mugaz_c + 44.01*gfrac(igas)
@@ -48,7 +49,16 @@
                cpp_c   = cpp_c   + 14.31*gfrac(igas)
                mugaz_c = mugaz_c + 2.01*gfrac(igas)
+            elseif(gnom(igas).eq.'He_')then
+               cpp_c   = cpp_c   + 5.19*gfrac(igas)
+               mugaz_c = mugaz_c + 4.003*gfrac(igas)
             elseif(gnom(igas).eq.'H2O')then
                cpp_c   = cpp_c   + 1.864*gfrac(igas)
                mugaz_c = mugaz_c + 18.02*gfrac(igas)
+            elseif(gnom(igas).eq.'SO2')then
+               cpp_c   = cpp_c   + 0.64*gfrac(igas)
+               mugaz_c = mugaz_c + 64.066*gfrac(igas)
+            elseif(gnom(igas).eq.'H2S')then
+               cpp_c   = cpp_c   + 1.003*gfrac(igas) ! from wikipedia...
+               mugaz_c = mugaz_c + 34.08*gfrac(igas)
             elseif(gnom(igas).eq.'CH4')then
                cpp_c   = cpp_c   + 2.226*gfrac(igas)
Index: trunk/LMDZ.GENERIC/libf/phystd/calc_rayleigh.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/calc_rayleigh.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/calc_rayleigh.F90	(revision 716)
@@ -74,4 +74,6 @@
             elseif(gnom(igas).eq.'He_')then
                print*,'Helium not ready yet!'
+               tauconsti(igas) = 0.0
+               call abort
             else
                print*,'Error in calc_rayleigh: Gas species not recognised!'
@@ -117,4 +119,7 @@
                   elseif(gnom(igas).eq.'H2_')then
                      tauvari(igas) = 1.0/wl**4 
+                  elseif(gnom(igas).eq.'He_')then
+                     print*,'Helium not ready yet!'
+                     tauvari(igas) = 0.0
                   else
                      print*,'Error in calc_rayleigh: Gas species not recognised!'
Index: trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 716)
@@ -7,5 +7,4 @@
           reffrad,tau_col,cloudfrac,totcloudfrac,              &
           clearsky,firstcall,lastcall)
-
 
       use radinc_h
@@ -201,5 +200,4 @@
       giaer(:,:,:) =0.0
       radfixed=.false.
-
 
       if(firstcall) then
@@ -275,6 +273,6 @@
          endif
 
-         OLR_nu=0.
-         OSR_nu=0.
+         OLR_nu(:,:) = 0.
+         OSR_nu(:,:) = 0.
 
          if (ngridmx.eq.1) then
@@ -429,5 +427,4 @@
            reffrad,QREFvis3d,QREFir3d,                             & 
            tau_col,cloudfrac,totcloudfrac,clearsky)                ! get aerosol optical depths
-
 
 !-----------------------------------------------------------------------
@@ -933,3 +930,4 @@
       endif
 
+
     end subroutine callcorrk
Index: trunk/LMDZ.GENERIC/libf/phystd/callkeys.h
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 716)
@@ -8,5 +8,5 @@
      &   , iaervar,iddist,topdustref,callstats,calleofdump              &
      &   , enertest                                                     &
-     &   , callgasvis,Continuum, graybody                               &
+     &   , callgasvis,Continuum,H2Ocont_simple,graybody                 &
      &   , Nmix_co2, Nmix_h2o                                           &
      &   , dusttau                                                      &
@@ -52,5 +52,5 @@
      &   , season,diurnal,tlocked,lwrite                                &
      &   , callstats,calleofdump                                        &
-     &   , callgasvis,Continuum,graybody
+     &   , callgasvis,Continuum,H2Ocont_simple,graybody
 
       logical enertest
Index: trunk/LMDZ.GENERIC/libf/phystd/cp_neutral.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/cp_neutral.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/cp_neutral.F90	(revision 716)
@@ -8,4 +8,8 @@
   double precision T
 
+
+  ! this function has been disabled in gradients_kcm.F90 because it dont
+  ! work if you have gaseous mixtures. need to decide whether to generalise
+  ! it or simply remove entirely...
 
   ! Cp_n : cf CO2 dans abe&matsui (1988)
Index: trunk/LMDZ.GENERIC/libf/phystd/datafile_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/datafile_mod.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/datafile_mod.F90	(revision 716)
@@ -4,8 +4,10 @@
       implicit none
 
+      ! Default for Berserker @ UChicago:
+!      character(len=300) :: datadir='/home/rwordsworth/datagcm'
       ! Default for Gnome Idataplex:
-      character(len=300) :: datadir='/san/home/rdword/gcm/datagcm'
+!      character(len=300) :: datadir='/san/home/rdword/gcm/datagcm'
       ! Default for LMD machines:
-!      character(len=300) :: datadir='/u/rwlmd/datagcm'
+      character(len=300) :: datadir='/u/rwlmd/datagcm'
 
       end module datafile_mod
Index: trunk/LMDZ.GENERIC/libf/phystd/gases_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/gases_h.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/gases_h.F90	(revision 716)
@@ -5,11 +5,11 @@
 !======================================================================C
 !
-!     GASES_H    
+!     gases_h    
 !
-!     THIS A F90-ALLOCATABLE VERSION FOR gases.h -- AS 12/2011
+!     A F90-allocatable version for gases.h -- AS 12/2011
 !
 !======================================================================C
 
-      !!! THOSE ARE SET AND ALLOCATED IN su_gases.F90
+      ! Set and allocated in su_gases.F90
       integer :: ngasmx
       integer :: vgas
@@ -17,3 +17,16 @@
       real,allocatable,DIMENSION(:) :: gfrac
 
+      ! in analogy with tracer.h ...
+      integer :: igas_H2
+      integer :: igas_He
+      integer :: igas_H2O
+      integer :: igas_CO2
+      integer :: igas_CO
+      integer :: igas_N2
+      integer :: igas_O2
+      integer :: igas_SO2
+      integer :: igas_H2S
+      integer :: igas_CH4
+      integer :: igas_NH3
+
       end module gases_h
Index: trunk/LMDZ.GENERIC/libf/phystd/gradients_kcm.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/gradients_kcm.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/gradients_kcm.F90	(revision 716)
@@ -14,5 +14,6 @@
 
   ! internal
-  double precision cp_n,cp_v
+  !double precision cp_n,cp_v
+  double precision cp_v
 
   double precision press, rho_plus, rho_minus, dVdT, rho_c
@@ -26,6 +27,5 @@
   double precision cp_neutral
 
-  cp_n = cp_neutral(T)
-
+  !cp_n = cp_neutral(T)
 
   select case(profil_flag)
Index: trunk/LMDZ.GENERIC/libf/phystd/inifis.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 716)
@@ -204,4 +204,8 @@
          write(*,*) " Continuum = ",Continuum
 
+         write(*,*) "use analytic function for H2O continuum ?"
+         H2Ocont_simple=.false. ! default value
+         call getin("H2Ocont_simple",H2Ocont_simple)
+         write(*,*) " H2Ocont_simple = ",H2Ocont_simple
  
          write(*,*) "call turbulent vertical diffusion ?"
@@ -221,5 +225,5 @@
 
          write(*,*) "call CO2 condensation ?"
-         co2cond=.true. ! default value
+         co2cond=.false. ! default value
          call getin("co2cond",co2cond)
          write(*,*) " co2cond = ",co2cond
@@ -228,6 +232,6 @@
             print*,'We need a CO2 ice tracer to condense CO2'
             call abort
-         endif	 
-	 
+         endif 
+ 
          write(*,*) "CO2 supersaturation level ?"
          co2supsat=1.0 ! default value
@@ -436,5 +440,5 @@
 
          write(*,*) "Gravitationnal sedimentation ?"
-         sedimentation=.true. ! default value
+         sedimentation=.false. ! default value
          call getin("sedimentation",sedimentation)
          write(*,*) " sedimentation = ",sedimentation
Index: trunk/LMDZ.GENERIC/libf/phystd/interpolateH2H2.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/interpolateH2H2.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/interpolateH2H2.F90	(revision 716)
@@ -6,9 +6,9 @@
 !     -------
 !     Calculates the H2-H2 CIA opacity, using a lookup table from
-!     Borysow (2002)
+!     HITRAN (2011)
 !
 !     Authors
 !     -------
-!     R. Wordsworth (2009)
+!     R. Wordsworth (2011)
 !     
 !==================================================================
@@ -26,6 +26,11 @@
 
       integer nS,nT
-      parameter(nS=1649)
-      parameter(nT=14)
+      parameter(nS=2428)
+      parameter(nT=10)
+
+      double precision, parameter :: losch = 2.6867774e19
+      ! Loschmit's number (molecule cm^-3 at STP) 
+      ! converts cm^5 molecule^-2 --> cm^-1 amagat^-2
+      ! see Richard et al. 2011, JQSRT for details
 
       double precision amagat
@@ -33,7 +38,6 @@
       double precision temp_arr(nT)
       double precision abs_arr(nS,nT)
-      double precision data_tmp(nT/2+1)
-
-      integer k
+
+      integer k,iT
       logical firstcall
 
@@ -43,66 +47,56 @@
       integer strlen,ios
 
-      amagat=(273.15/temp)*(pres/101325.0)
-
-      if(firstcall)then
+      character(LEN=*), parameter :: fmat1 = "(A20,F10.3,F10.3,I7,F7.1,E10.3,F5.3)"
+
+      character*20 bleh
+      double precision blah, Ttemp
+      integer nres
+
+      if(temp.gt.400)then
+         print*,'Your temperatures are too high for this H2-H2 CIA dataset. If you '
+         print*,'really want to run simulations with hydrogen at T > 400 K, contact'
+         print*,'Robin Wordsworth [rwordsworth@uchicago.edu].'
+         stop
+      endif
+
+      amagat = (273.15/temp)*(pres/101325.0)
+
+      if(firstcall)then ! called by sugas_corrk only
+         print*,'----------------------------------------------------'
+         print*,'Initialising H2-H2 continuum from HITRAN database...'
 
 !     1.1 Open the ASCII files
-
-         ! cold
-         dt_file=TRIM(datadir)//'/continuum_data/H2H2_CIA_LT.dat'
+         dt_file=TRIM(datadir)//'/continuum_data/H2-H2_norm_2011.cia'
+
          open(33,file=dt_file,form='formatted',status='old',iostat=ios)
          if (ios.ne.0) then        ! file not found
            write(*,*) 'Error from interpolateH2H2'
            write(*,*) 'Data file ',trim(dt_file),' not found.'
-           write(*,*)'Check that your path to datagcm:',trim(datadir)
-           write(*,*)' is correct. You can change it in callphys.def with:'
-           write(*,*)' datadir = /absolute/path/to/datagcm'
-           write(*,*)' Also check that there is a continuum_data/H2H2_CIA_LT.dat there.'
+           write(*,*) 'Check that your path to datagcm:',trim(datadir)
+           write(*,*) 'is correct. You can change it in callphys.def with:'
+           write(*,*) 'datadir = /absolute/path/to/datagcm'
+           write(*,*) 'Also check that the continuum data continuum_data/H2-H2_norm_2011.cia is there.'
            call abort
          else
-            do k=1,nS
-               read(33,*) data_tmp
-               wn_arr(k)=data_tmp(1)
-               abs_arr(k,1:7)=data_tmp(2:8)
+
+            do iT=1,nT
+
+               read(33,fmat1) bleh,blah,blah,nres,Ttemp
+               if(nS.ne.nres)then
+                  print*,'Resolution given in file: ',trim(dt_file)
+                  print*,'is ',nres,', which does not match nS.'
+                  print*,'Please adjust nS value in interpolateH2H2.F90'
+                  stop
+               endif
+               temp_arr(iT)=Ttemp
+
+               do k=1,nS
+                  read(33,*) wn_arr(k),abs_arr(k,it)
+               end do
+
             end do
+      
          endif
          close(33)
-
-         ! hot
-         dt_file=TRIM(datadir)//'/continuum_data/H2H2_CIA_HT.dat'
-         open(34,file=dt_file,form='formatted',status='old',iostat=ios)
-         if (ios.ne.0) then        ! file not found
-           write(*,*) 'Error from interpolateH2H2'
-           write(*,*) 'Data file ',trim(dt_file),' not found.'
-           write(*,*)'Check that your path to datagcm:',trim(datadir)
-           write(*,*)' is correct. You can change it in callphys.def with:'
-           write(*,*)' datadir = /absolute/path/to/datagcm'
-           write(*,*)' Also check that there is a continuum_data/H2H2_CIA_HT.dat there.'
-           call abort
-         else
-            do k=1,nS
-               read(34,*) data_tmp
-               wn_arr(k)=data_tmp(1)
-               ! wn_arr is identical
-               abs_arr(k,8:14)=data_tmp(2:8)
-            end do
-         endif
-         close(34)
-
-         temp_arr(1)  = 60.
-         temp_arr(2)  = 100.
-         temp_arr(3)  = 150.
-         temp_arr(4)  = 200.
-         temp_arr(5)  = 250.
-         temp_arr(6)  = 300.
-         temp_arr(7)  = 350.
-         temp_arr(8)  = 400.
-         temp_arr(9)  = 500.
-         temp_arr(10) = 600.
-         temp_arr(11) = 700.
-         temp_arr(12) = 800.
-         temp_arr(13) = 900.
-         temp_arr(14) = 1000.
-
 
          print*,'interpolateH2H2: At wavenumber ',wn,' cm^-1'
@@ -112,16 +106,36 @@
          call bilinearH2H2(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
 
-         print*,'the absorption is ',abcoef,' cm^-1 amg^-2'
-
-         abcoef=abcoef*100.0*amagat**2 ! convert to m^-1
-
-         print*,'We have ',amagat,' amagats'
+         print*,'the absorption is ',abcoef,' cm^5 molecule^-2'
+         print*,'or ',abcoef*losch**2,' cm^-1 amagat^-2'
+
+         abcoef=abcoef*losch**2*100.0*amagat**2 ! convert to m^-1
+
+         print*,'We have ',amagat,' amagats of H2'
          print*,'So the absorption is ',abcoef,' m^-1'
+
+               !open(117,file='T_array.dat')
+               !do iT=1,nT
+               !   write(117,*), temp_arr(iT)
+               !end do
+               !close(117)
+
+               !open(115,file='nu_array.dat')
+               !do k=1,nS
+               !   write(115,*), wn_arr(k)
+               !end do
+               !close(115)
+
+               !open(113,file='abs_array.dat')
+               !do iT=1,nT
+               !   do k=1,nS
+               !      write(113,*), abs_arr(k,iT)*losch**2
+               !   end do
+               !end do
+               !close(113)
 
       else
   
          call bilinearH2H2(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
-         abcoef=abcoef*100.0*amagat**2 ! convert to m^-1
-         !print*,'The absorption is ',abcoef,' m^-1'
+         abcoef=abcoef*losch**2*100.0*amagat**2 ! convert to m^-1
 
          ! unlike for Rayleigh scattering, we do not currently weight by the BB function
@@ -141,6 +155,6 @@
 
       integer nX,nY,i,j,a,b
-      parameter(nX=1649)
-      parameter(nY=14)
+      parameter(nX=2428)
+      parameter(nY=10)
 
       real*8 x_in,y_in,x,y,x1,x2,y1,y2
@@ -156,4 +170,5 @@
       x=x_in
       y=y_in
+
 
 !     1st check we're within the wavenumber range
@@ -180,5 +195,4 @@
          write(*,*) 'Warning from bilinearH2H2:'
          write(*,*) 'Outside continuum temperature range!'
-         write(*,*) y,y_arr(1),y_arr(nY)
          if(y.lt.y_arr(1))then
             y=y_arr(1)+0.01
@@ -187,6 +201,5 @@
             y=y_arr(nY)-0.01
          endif
-      endif
-      !else
+      else
 
 !     in the y (temperature) direction 2nd
@@ -202,5 +215,5 @@
             goto 20
          endif
-      !endif
+      endif
       
       f11=f2d_arr(a,b)
@@ -208,12 +221,7 @@
       f12=f2d_arr(a,b+1)
       f22=f2d_arr(a+1,b+1)
-      
-!     1st in x-direction
-      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
-      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
-      
-!     then in y-direction
-      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
-      
+
+      call bilinear(f,f11,f21,f12,f22,x,x1,x2,y,y1,y2)
+
       return
     end subroutine bilinearH2H2
Index: trunk/LMDZ.GENERIC/libf/phystd/interpolateH2He.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/interpolateH2He.F90	(revision 716)
+++ trunk/LMDZ.GENERIC/libf/phystd/interpolateH2He.F90	(revision 716)
@@ -0,0 +1,212 @@
+     subroutine interpolateH2He(wn,temp,presH2,presHe,abcoef,firstcall)
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates the H2-He CIA opacity, using a lookup table from
+!     HITRAN (2011)
+!
+!     Authors
+!     -------
+!     R. Wordsworth (2011)
+!     
+!==================================================================
+
+      use datafile_mod, only: datadir
+      implicit none
+
+      ! input
+      double precision wn                 ! wavenumber             (cm^-1)
+      double precision temp               ! temperature            (Kelvin)
+      double precision presH2             ! H2 partial pressure    (Pascals)
+      double precision presHe             ! He partial pressure    (Pascals)
+
+      ! output
+      double precision abcoef             ! absorption coefficient (m^-1)
+
+      integer nS,nT
+      parameter(nS=2428)
+      parameter(nT=10)
+
+      double precision, parameter :: losch = 2.6867774e19
+      ! Loschmit's number (molecule cm^-3 at STP) 
+      ! converts cm^5 molecule^-2 --> cm^-1 amagat^-2
+      ! see Richard et al. 2011, JQSRT for details
+
+      double precision amagatH2
+      double precision amagatHe
+      double precision wn_arr(nS)
+      double precision temp_arr(nT)
+      double precision abs_arr(nS,nT)
+
+      integer k,iT
+      logical firstcall
+
+      save wn_arr, temp_arr, abs_arr
+
+      character*100 dt_file
+      integer strlen,ios
+
+      character(LEN=*), parameter :: fmat1 = "(A20,F10.3,F10.3,I7,F7.1,E10.3,F5.3)"
+
+      character*20 bleh
+      double precision blah, Ttemp
+      integer nres
+
+
+      if(temp.gt.400)then
+         print*,'Your temperatures are too high for this H2-He CIA dataset.'
+         print*,'Please run mixed H2-He atmospheres below T = 400 K.'      
+         stop
+      endif
+
+      amagatH2 = (273.15/temp)*(presH2/101325.0)
+      amagatHe = (273.15/temp)*(presHe/101325.0)
+
+      if(firstcall)then ! called by sugas_corrk only
+         print*,'----------------------------------------------------'
+         print*,'Initialising H2-He continuum from HITRAN database...'
+
+!     1.1 Open the ASCII files
+         dt_file=TRIM(datadir)//'/continuum_data/H2-He_norm_2011.cia'
+
+         open(33,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+           write(*,*) 'Error from interpolateH2He'
+           write(*,*) 'Data file ',trim(dt_file),' not found.'
+           write(*,*) 'Check that your path to datagcm:',trim(datadir)
+           write(*,*) 'is correct. You can change it in callphys.def with:'
+           write(*,*) 'datadir = /absolute/path/to/datagcm'
+           write(*,*) 'Also check that the continuum data continuum_data/H2-He_norm_2011.cia is there.'
+           call abort
+         else
+
+            do iT=1,nT
+
+               read(33,fmat1) bleh,blah,blah,nres,Ttemp
+               if(nS.ne.nres)then
+                  print*,'Resolution given in file: ',trim(dt_file)
+                  print*,'is ',nres,', which does not match nS.'
+                  print*,'Please adjust nS value in interpolateH2He.F90'
+                  stop
+               endif
+               temp_arr(iT)=Ttemp
+
+               do k=1,nS
+                  read(33,*) wn_arr(k),abs_arr(k,it)
+               end do
+
+            end do
+      
+         endif
+         close(33)
+
+         print*,'interpolateH2He: At wavenumber ',wn,' cm^-1'
+         print*,'   temperature                 ',temp,' K'
+         print*,'   H2 partial pressure         ',presH2,' Pa'
+         print*,'   and He partial pressure     ',presHe,' Pa'
+
+         call bilinearH2He(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
+
+         print*,'the absorption is ',abcoef,' cm^5 molecule^-2'
+         print*,'or ',abcoef*losch**2,' cm^-1 amagat^-2'
+
+         abcoef=abcoef*losch**2*100.0*amagatH2*amagatHe ! convert to m^-1
+
+         print*,'We have ',amagatH2,' amagats of H2'
+         print*,'and     ',amagatHe,' amagats of He'
+         print*,'So the absorption is ',abcoef,' m^-1'
+
+      else
+  
+         call bilinearH2He(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
+         abcoef=abcoef*losch**2*100.0*amagatH2*amagatHe ! convert to m^-1
+
+         ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+         ! however our bands are normally thin, so this is no big deal.
+
+      endif
+
+      return
+    end subroutine interpolateH2He
+
+
+!-------------------------------------------------------------------------
+      subroutine bilinearH2He(x_arr,y_arr,f2d_arr,x_in,y_in,f)
+!     Necessary for interpolation of continuum data
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+      parameter(nX=2428)
+      parameter(nY=10)
+
+      real*8 x_in,y_in,x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+      x=x_in
+      y=y_in
+
+!     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+         return
+      else
+         
+!     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Warning from bilinearH2He:'
+         write(*,*) 'Outside continuum temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+      else
+
+!     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+
+      call bilinear(f,f11,f21,f12,f22,x,x1,x2,y,y1,y2)
+
+      
+      return
+    end subroutine bilinearH2He
